# xreducer

Defined in `xtensor/xreducer.hpp`

template <class F, class CT, class X>
class `xt::``xreducer`

  Reducing function operating over specified axes.

  The xreducer class implements an xexpression applying a reducing function to an xexpression over the specified axes.

  See
    reduce
  Template Parameters
    - `F`: the function type
    - `CT`: the closure type of the xexpression to reduce
    - `X`: the list of axes

  Inherits from xt::xexpression< xreducer< F, CT, X > >, xt::xexpression_const_iterable< xreducer< F, CT, X > >

  Constructor

  template <class Func, class CTA, class AX>
  `xreducer`(Func &&func, CTA &&e, AX &&axes)

    Constructs an xreducer expression applying the specified function to the given expression over the given axes.

    Parameters
      - `func`: the function to apply
      - `e`: the expression to reduce
      - `axes`: the axes along which the reduction is performed

  Size and shape

  auto `size`() const

    Returns the size of the expression.

  auto `dimension`() const

    Returns the number of dimensions of the expression.

  auto `shape`() const

    Returns the shape of the expression.

  layout_type `layout`() const

    Returns the shape of the expression.

  Data

  auto `operator[]`(const xindex &index) const

    Returns a constant reference to the element at the specified position in the reducer.

    Parameters
      - `index`: a sequence of indices specifying the position in the reducer. Indices must be unsigned integers, the number of indices in the sequence should be equal or greater than the number of dimensions of the reducer.
  template <class... Args>
  auto `operator()`(Args... args) const

    Returns a constant reference to the element at the specified position in the reducer.

    Parameters
      - `args`: a list of indices specifying the position in the reducer. Indices must be unsigned integers, the number of indices should be equal or greater than the number of dimensions of the reducer.
  template <class It>
  auto `element`(It first, It last) const

    Returns a constant reference to the element at the specified position in the reducer.

    Parameters
      - `first`: iterator starting the sequence of indices
      - `last`: iterator ending the sequence of indices The number of indices in the sequence should be equal to or greater than the number of dimensions of the reducer.

  Broadcasting

  template <class S>
  bool `broadcast_shape`(S &shape) const

    Broadcast the shape of the reducer to the specified parameter.

    Return
      a boolean indicating whether the broadcasting is trivial
    Parameters
      - `shape`: the result shape
  template <class S>
  bool `is_trivial_broadcast`(const S &strides) const

    Compares the specified strides with those of the container to see whether the broadcasting is trivial.

    Return
      a boolean indicating whether the broadcasting is trivial

template <class F, class E, class X>
auto `xt::``reduce`(F &&f, E &&e, X &&axes)

  Returns an xexpression applying the speficied reducing function to an expresssion over the given axes.

  The returned expression either hold a const reference to `e` or a copy depending on whether `e` is an lvalue or an rvalue.

  Parameters
    - `f`: the reducing function to apply.
    - `e`: the xexpression to reduce.
    - `axes`: the list of axes.